:root {
	--log-item-padding: 10px;
}

.log.scroll {
	width: calc(100% - 4px);
	border-spacing: 0;
	border-collapse: collapse;
	border: 2px solid #c7c7c7;
	display: block;
	overflow-y: scroll;
}

.log.scroll thead {
	text-align: center;
	background: #c7c7c7;
	position: sticky;
	top: 0;
	display: block;
	box-shadow: 0px 0px 10px 0px #5f5f5f;
}

.log.scroll tbody {
	display: block;
}

.log.scroll tr {
	display: flex;
}

.log.scroll tbody tr:nth-child(even) {
	background: #ececec;
}

.log.scroll tbody tr:nth-child(odd) {
	background: #ffffff;
}

.log tr[data-type="success"]:nth-child(even) {
	background: #6bbb6b!important;
}

.log tr[data-type="success"]:nth-child(odd) {
	background: #81cc81!important;
}

.log tr[data-type="warning"]:nth-child(even) {
	background: #f5f56e!important;
}

.log tr[data-type="warning"]:nth-child(odd) {
	background: #fbfb93!important;
}

.log th {
	padding: 15px;
}

.log td {
	padding: 10px;
}

.log th[topic="time"],
.log td[topic="time"] {
	width: 15%;
	text-align: center;
}

.log th[topic="msg"],
.log td[topic="msg"] {
	width: 45%;
	font-size: 14px;
}

.log th[topic="details"],
.log td[topic="details"] {
	width: 30%;
	font-size: 14px;
}

.log th[topic="type"],
.log td[topic="type"] {
	text-align: center;
	width: 10%;
	font-size: 14px;
}

.log li.detail {
	display: grid;
	grid-template-columns: 1fr 2fr;
	color: #40404073;
}

.log li.detail > div.detail-key {
	font-weight: bold;
}

@media (pointer: coarse) {
	.log th[topic="details"],
	.log th[topic="type"],
	.log td[topic="details"],
	.log td[topic="type"] {
		display: none;
	}
	
	.log th[topic="time"],
	.log td[topic="time"] {
		width: 30%;
		text-align: center;
	}

	.log th[topic="msg"],
	.log td[topic="msg"] {
		width: 70%;
	}
}

.log-details {
	margin-top: auto;
	padding-top: 1rem;
	position: relative;
	box-sizing: border-box;
}

.log-details > * {
	box-sizing: inherit;
}

.log-page-count {
	width: 250px;
	position: relative;
	margin: 0 auto 0 auto;
	height: 50px;
	background: gainsboro;
	border-radius: 4px;
	border: 1px solid #73737369;
	display: grid;
	grid-template-areas:
		"first prev count next last";
	grid-template-columns:
		1fr 1fr 1.5fr 1fr 1fr;
}

.log-page-count > div.center {
	position: relative;
}

.log-page-count > div.center > *,
.log-item-count > span,
.log-page-size > input {
	position: absolute;
	top: 0;
	right: 0;
	left: 0;
	bottom: 0;
	margin: auto;
	width: fit-content;
	height: fit-content;
	padding: 8px;
}

.log-page-count > div.center[topic="first"] > span,
.log-page-count > div.center[topic="next"]  > span {
	margin-right: 0;
	border-top-left-radius: 4px;
	border-bottom-left-radius: 4px;
	border-right: none;
}

.log-page-count > div.center[topic="prev"] > span,
.log-page-count > div.center[topic="last"] > span {
	margin-left: 0;
	border-top-right-radius: 4px;
	border-bottom-right-radius: 4px;
	border-left: none;
}

.log-page-count > div.center[topic="next"] > span { border-right: 1px solid #adadad; }
.log-page-count > div.center[topic="prev"] > span { border-left: 1px solid #adadad; }

.log-page-count > div.center > span,
.log-item-count > span,
.log-page-size > input {
	background: #cacaca;
	height: 20px;
	width: 20px;
	border: 1px solid #adadad;
	text-align: center;
}

.log-page-count > div.center > span:hover {
	cursor: pointer;
}

.log-page-count > div[topic="first"] { grid-area: first; }
.log-page-count > div[topic="prev"]  { grid-area: prev;  }
.log-page-count > div[topic="count"] { grid-area: count; }
.log-page-count > div[topic="next"]  { grid-area: next;  }
.log-page-count > div[topic="last"]  { grid-area: last;  }

.log-page-counter > a {
	padding: 0 5px;
}

.log-item-count,
.log-page-size {
	position: absolute;
	top: 1rem;
	height: 50px;
	overflow: hidden;
	border-radius: 4px;
	background: gainsboro;
	border: 1px solid #73737369;
}

.log-item-count {
	right: 0;
	width: 80px;
	max-width: 80px;
}

.log-page-size {
	left: 0;
	width: 90px;
	max-width: 90px;
}

.log-page-size > input {
	width: 60px;
	border-radius: 4px;
}

.log-item-count > span {
	border-radius: 4px;
	width: 50px;
}